(function ($) {
    $(function () {
        var periodSelectElement = $('#selectedPeriodId');
        var dataSetSelectElement = $('#selectedDataSetId');

        /**
         * TODO: Perhaps you need to change the event handler based
         * on when you want to load the data.
         * Additionally you might want to do add a few more event handlers
         * for when someone changes the org unit or so. 
         */
        $('#selectedPeriodId').on('change', getDataForPreviousPeriod);

        /**************************************************************/

        /*
         * Note: The following functions will help to get the previous period.
         * Currently it will only take previous period as they are in the period selectbox.
         * This could also be achieved by just selecting the option value element before the 
         * currently selected one. I included the period generator stuff however so you can also
         * make it go across the boundries of the year if you would like to.
         * You would then depending on if it is the first or last element of the period set
         * change the dhis2.de.currentPeriodOffset with +1 or -1. But i will let you figure that
         * out for yourself.
         */
        function getPeriodBeforeTheCurrentOne() {
            var currentPeriod = getSelectedPeriod();
            var previousPeriod = generatePeriods().filter(function (period, index, periods) {
                return periods[index+1] && periods[index+1].iso === currentPeriod;
            });

            if (previousPeriod.length === 1) {
                return previousPeriod[0].iso;
            }
            return false;
        }

        

        function getSelectedDataSetId() {
            return dataSetSelectElement.val();
        }

        function getSelectedPeriod() {
            return periodSelectElement.val();
        }

        function getPeriodType() {
            return dhis2.de.dataSets[getSelectedDataSetId()].periodType;
        }

        function generatePeriods() {
            return dhis2.period.generator.generatePeriods(getPeriodType(), dhis2.de.currentPeriodOffset);
        }

        function getSelectedOrganisationUnit() {
            return selection.getSelected();
        }

        function getDataForPreviousPeriod() {
            var dataSetId = getSelectedDataSetId();
            var orgUnitId = getSelectedOrganisationUnit();
            var period = getPeriodBeforeTheCurrentOne();
            var url = [
                'https://apps.dhis2.org/demo/api/dataValueSets',
                ['dataSet=' + dataSetId, 'period=' + period, 'orgUnit=' + orgUnitId].join('&')
            ].join('?');

            if (dataSetId && orgUnitId && period) {
                $.get(url)
                    .success(processPreviousData)
                    .error(console.error);
            } else {
                console.log('Previous period not found');
            }
        }

        function processPreviousData(data) {
            //TODO: You will have to do something there to display the previous data
            console.log(data)
        }
    });
})(window.jQuery);